// g++ app.c -o app.x
#include <string>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <float.h>
#include <fstream.h>
#include <iostream.h>
#include "recipes/gammln_.c"
#include "recipes/nrutil.c"
using namespace std;
//
//#define MAXCANDIDATES 100000
//
double logMultinomialIntegral(int iCandidate,int ipdf,int *pdfOrder,double ***nVotes);
double logSame(int iCandidate,int jCandidate,int nPdfs,int *pdfOrder,double ***nVotes);
//
int MAXORDER=30; // maximum order of multinomial
int main(int argc, char* argv[])
{
  
 int i,ipdf,iarg,iCandidate,jCandidate;
 char dataFileName[1024],outFileName[1024];
 sprintf(outFileName,"results.txt");
 if (argc==1)
 {
  cout<<"app.x -DATAFILE <filename> [-OUTFILE <filename>]"<<endl;
  cout<<"(arguments in brackets are optional)"<<endl;
  exit(0);
 }
 for (iarg=1;iarg<argc;iarg++)
 {
  if (!strcmp("-OUTFILE",argv[iarg]))
  {
   iarg++;
   strcpy(outFileName,argv[iarg]);
  }
 }
 for (iarg=1;iarg<argc;iarg++)
 {
  if (!strcmp(argv[iarg],"-DATAFILE"))
  {
   iarg++;
   strcpy(dataFileName,argv[iarg]);
  }
 }
//
 cout<<"outputting results to "<<outFileName<<endl; 
// get number of candidates in file
 ifstream dataFile(dataFileName);
 if (!dataFile)
 {
  cout<<"Yeah, I can't find "<<dataFileName<<" -- go boil your head!"<<endl;
  exit(0);
 }
// find out how many candiates are in the file 
 char dummy[1024]; 
 int nCandidates=0;
 string pdfString;
 dataFile.getline(dummy,1024);
 pdfString=dummy;
 while (dataFile.getline(dummy,1024))
 {
  nCandidates++;
 }
 dataFile.close();
// allocate memory for candidateName now that I know the number of candidates 
string candidateName[nCandidates];
// declare nVotes -- 
 double ***nVotes; 
 nVotes=d3tensor(0,nCandidates,0,pdfString.size(),0,MAXORDER);
// now take the pdf string and parse it
 int *pdfOrder; // order of multinomial
 pdfOrder=ivector(0,pdfString.size()-1);
 for (i=0;i<pdfString.size();i++)
 { 
  char character=pdfString[i];
  pdfOrder[i]=atoi(&character);
  if (pdfOrder[i]>MAXORDER)
  {
   cout<<"order of "<<i<<"th pdf is "<<MAXORDER<<endl;
   cout<<"increase MAXORDER"<<endl;
   cout<<"exiting...."<<endl;
  }
 }
// ok, now read the data in
 dataFile.open(dataFileName);
 dataFile.getline(dummy,1024); // pdf string -- already read it.
 iCandidate=0;
 cout<<"nCandidates="<<nCandidates<<endl;
 while (dataFile>>candidateName[iCandidate])
 {
//   cout<<"nVotes="<<nVotes[iCandidate][0][0]<<endl;
//   cout<<"pdfString.size()="<<pdfString.size()<<endl;
  for (ipdf=0;ipdf<pdfString.size();ipdf++)
  {
//    cout<<"pdfOrder["<<ipdf<<"]="<<ipdf<<endl;
   for (i=0;i<pdfOrder[ipdf];i++)
    dataFile>>nVotes[iCandidate][ipdf][i];
  }
  iCandidate++;
 }
 ofstream outFile(outFileName);
 outFile<<"[Cand1 ID] [Cand2 ID] [logPDiff] [logPSame] [logPDiff-logPSame]"<<endl;
 if (!outFile)
 {
  cout<<"could not open "<<outFileName<<" for some reason... exiting..."<<endl;
  exit(0);
 }
 for (iCandidate=0;iCandidate<nCandidates;iCandidate++)
  for (jCandidate=iCandidate+1;jCandidate<nCandidates;jCandidate++)
  {
// calc prob 2 cands are different
   double logPDiff=0.; 
   for (ipdf=0;ipdf<pdfString.size();ipdf++)
   {
    logPDiff+=logMultinomialIntegral(iCandidate,ipdf,pdfOrder,nVotes);
    logPDiff+=logMultinomialIntegral(jCandidate,ipdf,pdfOrder,nVotes);
   }
   cout<<"comparing "<<candidateName[iCandidate]<<" with "<<candidateName[jCandidate]<<": logPDiff= "<<logPDiff<<" logSame= "<<logSame(iCandidate,jCandidate,pdfString.size(),pdfOrder,nVotes)
   <<" logPDiff-logSame="<<logPDiff-logSame(iCandidate,jCandidate,pdfString.size(),pdfOrder,nVotes)<<endl;
   outFile<<candidateName[iCandidate]<<" "<<candidateName[jCandidate]<<" "<<logPDiff<<" "<<logSame(iCandidate,jCandidate,pdfString.size(),pdfOrder,nVotes)<<" "<<logPDiff-logSame(iCandidate,jCandidate,pdfString.size(),pdfOrder,nVotes)<<endl;
  }
  dataFile.close();
}


double logMultinomialIntegral(int iCandidate,int ipdf,int *pdfOrder,double ***nVotes)
{
 int i;
 double answer=0.;
 double totVotes=0.;
 for (i=0;i<pdfOrder[ipdf];i++)
  totVotes+=nVotes[iCandidate][ipdf][i];
// get formula from 'dirichlet-multinomial distribution' on wiki  
// calc stuff for iCand 1
 answer+=gammln_(double(pdfOrder[ipdf]))-gammln_(totVotes+pdfOrder[ipdf]);
 for (i=0;i<pdfOrder[ipdf];i++)
  answer+=gammln_(nVotes[iCandidate][ipdf][i]+1.)-gammln_(1.);
 return answer;
}
//
double logSame(int iCandidate,int jCandidate,int nPdfs,int *pdfOrder,double ***nVotes)
{
 int i;
 int ipdf;
 double answer=0.;
 double totVotes;
 for (ipdf=0;ipdf<nPdfs;ipdf++)
 {
  totVotes=0.;
  for (i=0;i<pdfOrder[ipdf];i++)
   totVotes+=nVotes[iCandidate][ipdf][i]+nVotes[jCandidate][ipdf][i];
  answer+=gammln_(double(pdfOrder[ipdf]))-gammln_(totVotes+pdfOrder[ipdf]);
  for (i=0;i<pdfOrder[ipdf];i++)
   answer+=gammln_(nVotes[iCandidate][ipdf][i]+nVotes[jCandidate][ipdf][i]+1.)-gammln_(1.);
 }
 return answer;
}
